class Dieta
    include Comparable
    attr_accessor :titulo, :porcentaje, :platos, :porcion, :gramos, :kcal, :pgh
    
    def initialize(titulo, porcentaje, platos, porcion, gramos, kcal, pgh)
        @titulo = titulo
        @porcentaje = porcentaje
        @platos = platos
        @porcion = porcion
        @gramos = gramos
        @kcal = kcal
        @pgh = pgh
    end
    
    def to_s
        aux = "#{titulo} (#{porcentaje})\n"
        i = 0
        while i < @platos.size
            aux = aux + "- #{@platos[i]}, #{@porcion[i]}, #{@gramos[i]} g\n"
            i = i + 1
        end
        aux = aux + "V.C.T. | % #{kcal} Kcal |"
        i = 0
        while i < @pgh.size
            aux = aux + " #{@pgh[i]}%"
            if(i < @pgh.size-1)
                aux = aux + " -"
            end
            i = i + 1
        end
        return aux
    end
    
    def <=>(anOther)
       self.kcal <=> anOther.kcal
    end
    
    def == (anOther)
        return(kcal == anOther.kcal) && (pgh == anOther.pgh)
    end
end