Node = Struct.new(:value, :next, :prev)

class Lista
    attr_accessor :head,:size,:tail
    include Enumerable
    def initialize()
        @head = nil
        @tail = nil
        @size = 0
    end
    
    def insert(nodo)
        if(head == nil)
            self.head = nodo
            self.size += 1
        else
           nodo.next = head
           self.head = nodo
           self.size += 1
        end
    end
     
    def pop()
        aux = self.head
        self.head = self.head.next
        aux.next = nil
        self.size =self.size - 1
    end
    
    def insertBeginning(nodo)
       if(head == nil) 
            self.head = nodo
            self.tail = nodo
            self.size += 1
       else
           self.head.prev = nodo
           nodo.next = self.head
           self.head = nodo
           self.size += 1
       end    
    end
    
    def insertEnd(nodo)
       if(head == nil) 
            self.head = nodo
            self.tail = nodo
            self.size += 1
       else
           self.tail.next = nodo
           nodo.prev = self.tail
           self.tail = nodo
           self.size += 1
       end    
    end
    
    def extractBeginning()
        aux = self.head.next
        aux.prev = nil
        self.head.next = nil
        self.head = aux
        aux = nil
        self.size -= 1
    end
    
    def extractEnd()
        aux = self.tail.prev
        self.tail.prev = nil
        aux.next = nil
        self.tail = aux
        aux = nil
        self.size -= 1
    end
    
    def each
        if(@head == nil) && (@tail == nil)
            yield nil
        elseif(@head == @tail)
            yield @head-value
        else
            while(@head != nil)
                yield @head.value
                @head = @head.next
            end
        end
    end
    
end